diff --git a/oflog/libsrc/filter.cc b/oflog/libsrc/filter.cc
index 62a4f52..e9fd1e3 100644
--- a/oflog/libsrc/filter.cc
+++ b/oflog/libsrc/filter.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -21,19 +21,20 @@
 #include "dcmtk/oflog/spi/filter.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/helpers/strhelp.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/thread/syncpub.h"
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::spi;
-using namespace dcmtk::log4cplus::helpers;
 
+namespace dcmtk {
+namespace log4cplus { namespace spi {
 
 ///////////////////////////////////////////////////////////////////////////////
 // global methods
 ///////////////////////////////////////////////////////////////////////////////
 
 FilterResult
-spi::checkFilter(const Filter* filter,
-                            const InternalLoggingEvent& event)
+checkFilter(const Filter* filter, const InternalLoggingEvent& event)
 {
     const Filter* currentFilter = filter;
     while(currentFilter) {
@@ -54,7 +55,7 @@ spi::checkFilter(const Filter* filter,
 // Filter implementation
 ///////////////////////////////////////////////////////////////////////////////
 
-Filter::Filter()
+Filter::Filter() : next()
 {
 }
 
@@ -67,12 +68,10 @@ Filter::~Filter()
 void
 Filter::appendFilter(FilterPtr filter)
 {
-    if(next.get() == 0) {
+    if (! next)
         next = filter;
-    }
-    else {
+    else
         next->appendFilter(filter);
-    }
 }
 
 
@@ -85,7 +84,7 @@ DenyAllFilter::DenyAllFilter ()
 { }
 
 
-DenyAllFilter::DenyAllFilter (const Properties&, tstring&)
+DenyAllFilter::DenyAllFilter (const helpers::Properties&)
 { }
 
 
@@ -102,21 +101,24 @@ DenyAllFilter::decide(const InternalLoggingEvent&) const
 ///////////////////////////////////////////////////////////////////////////////
 
 LogLevelMatchFilter::LogLevelMatchFilter()
+    : acceptOnMatch(), logLevelToMatch()
 {
     init();
 }
 
 
 
-LogLevelMatchFilter::LogLevelMatchFilter(const Properties& properties, tstring&)
+LogLevelMatchFilter::LogLevelMatchFilter(const helpers::Properties& properties)
+    : acceptOnMatch(), logLevelToMatch()
 {
     init();
 
-    tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("AcceptOnMatch") );
-    acceptOnMatch = (toLower(tmp) == DCMTK_LOG4CPLUS_TEXT("true"));
+    properties.getBool (acceptOnMatch = false,
+        DCMTK_LOG4CPLUS_TEXT("AcceptOnMatch"));
 
-    tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("LogLevelToMatch") );
-    logLevelToMatch = getLogLevelManager().fromString(tmp);
+    tstring const & log_level_to_match
+        = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("LogLevelToMatch") );
+    logLevelToMatch = getLogLevelManager().fromString(log_level_to_match);
 }
 
 
@@ -136,7 +138,7 @@ LogLevelMatchFilter::decide(const InternalLoggingEvent& event) const
     }
 
     bool matchOccured = (logLevelToMatch == event.getLogLevel());
-
+       
     if(matchOccured) {
         return (acceptOnMatch ? ACCEPT : DENY);
     }
@@ -152,24 +154,28 @@ LogLevelMatchFilter::decide(const InternalLoggingEvent& event) const
 ///////////////////////////////////////////////////////////////////////////////
 
 LogLevelRangeFilter::LogLevelRangeFilter()
+    : acceptOnMatch(), logLevelMin(), logLevelMax()
 {
     init();
 }
 
 
 
-LogLevelRangeFilter::LogLevelRangeFilter(const Properties& properties, tstring&)
+LogLevelRangeFilter::LogLevelRangeFilter(const helpers::Properties& properties)
+    : acceptOnMatch(), logLevelMin(), logLevelMax()
 {
     init();
 
-    tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("AcceptOnMatch") );
-    acceptOnMatch = (toLower(tmp) == DCMTK_LOG4CPLUS_TEXT("true"));
+    properties.getBool (acceptOnMatch = false,
+        DCMTK_LOG4CPLUS_TEXT("AcceptOnMatch"));
 
-    tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("LogLevelMin") );
-    logLevelMin = getLogLevelManager().fromString(tmp);
+    tstring const & log_level_min
+        = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("LogLevelMin") );
+    logLevelMin = getLogLevelManager().fromString(log_level_min);
 
-    tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("LogLevelMax") );
-    logLevelMax = getLogLevelManager().fromString(tmp);
+    tstring const & log_level_max
+        = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("LogLevelMax") );
+    logLevelMax = getLogLevelManager().fromString(log_level_max);
 }
 
 
@@ -213,19 +219,20 @@ LogLevelRangeFilter::decide(const InternalLoggingEvent& event) const
 ///////////////////////////////////////////////////////////////////////////////
 
 StringMatchFilter::StringMatchFilter()
+    : acceptOnMatch(), stringToMatch()
 {
     init();
 }
 
 
 
-StringMatchFilter::StringMatchFilter(const Properties& properties, tstring&)
+StringMatchFilter::StringMatchFilter(const helpers::Properties& properties)
+    : acceptOnMatch(), stringToMatch()
 {
     init();
 
-    tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("AcceptOnMatch") );
-    acceptOnMatch = (toLower(tmp) == DCMTK_LOG4CPLUS_TEXT("true"));
-
+    properties.getBool (acceptOnMatch = false,
+        DCMTK_LOG4CPLUS_TEXT("AcceptOnMatch"));
     stringToMatch = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("StringToMatch") );
 }
 
@@ -242,7 +249,7 @@ StringMatchFilter::decide(const InternalLoggingEvent& event) const
 {
     const tstring& message = event.getMessage();
 
-    if(stringToMatch.length() == 0 || message.length() == 0) {
+    if(stringToMatch.empty () || message.empty ()) {
         return NEUTRAL;
     }
 
@@ -254,3 +261,6 @@ StringMatchFilter::decide(const InternalLoggingEvent& event) const
     }
 }
 
+
+} } // namespace log4cplus { namespace spi {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/globinit.cc b/oflog/libsrc/globinit.cc
index f0a9f46..113d012 100644
--- a/oflog/libsrc/globinit.cc
+++ b/oflog/libsrc/globinit.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -19,32 +19,397 @@
 // limitations under the License.
 
 #include "dcmtk/oflog/config.h"
+#include "dcmtk/oflog/config/windowsh.h"
 #include "dcmtk/oflog/logger.h"
 #include "dcmtk/oflog/ndc.h"
+#include "dcmtk/oflog/mdc.h"
 #include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include "dcmtk/oflog/thread/impl/tls.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/spi/factory.h"
+#include "dcmtk/oflog/hierarchy.h"
+#include "dcmtk/ofstd/ofconsol.h"
+#include <cstdio>
+#include <iostream>
+#include <stdexcept>
 
 
 // Forward Declarations
 namespace dcmtk
 {
-
 namespace log4cplus
 {
 
+#ifdef UNICODE
+DCMTK_LOG4CPLUS_EXPORT tostream & tcout = STD_NAMESPACE wcout;
+DCMTK_LOG4CPLUS_EXPORT tostream & tcerr = STD_NAMESPACE wcerr;
+
+#else
+DCMTK_LOG4CPLUS_EXPORT tostream & tcout = COUT;
+DCMTK_LOG4CPLUS_EXPORT tostream & tcerr = CERR;
+
+#endif // UNICODE
+
+
+namespace 
+{
+
+
+//! Default context.
+struct DefaultContext
+{
+    DefaultContext() :
+        console_mutex(),
+        loglog(),
+        log_level_manager(),
+        TTCCLayout_time_base(),
+        ndc(),
+        mdc(),
+        hierarchy(),
+        appender_factory_registry(),
+        layout_factory_registry(),
+        filter_factory_registry(),
+        locale_factory_registry() {
+    }
+    log4cplus::thread::Mutex console_mutex;
+    helpers::LogLog loglog;
+    LogLevelManager log_level_manager;
+    helpers::Time TTCCLayout_time_base;
+    NDC ndc;
+    MDC mdc;
+    Hierarchy hierarchy;
+    spi::AppenderFactoryRegistry appender_factory_registry;
+    spi::LayoutFactoryRegistry layout_factory_registry;
+    spi::FilterFactoryRegistry filter_factory_registry;
+    spi::LocaleFactoryRegistry locale_factory_registry;
+};
+
+
+enum DCState
+{ 
+    DC_UNINITIALIZED,
+    DC_INITIALIZED,
+    DC_DESTROYED
+};
+
+
+static DCState default_context_state;
+static DefaultContext * default_context;
+
+   
+struct destroy_default_context
+{
+    ~destroy_default_context ()
+    {
+        delete default_context;
+        default_context = 0;
+        default_context_state = DC_DESTROYED;
+    }
+} static destroy_default_context_;
+
+
+static
+void
+alloc_dc ()
+{
+    assert (! default_context);
+    assert (default_context_state == DC_UNINITIALIZED);
+
+    if (default_context)
+        throw STD_NAMESPACE logic_error (
+            "alloc_dc() called with non-NULL default_context.");
+
+    if (default_context_state == DC_INITIALIZED)
+        throw STD_NAMESPACE logic_error ("alloc_dc() called in DC_INITIALIZED state.");
+
+    default_context = new DefaultContext;
+    
+    if (default_context_state == DC_DESTROYED)
+        default_context->loglog.error (
+            DCMTK_LOG4CPLUS_TEXT ("Re-initializing default context after it has")
+            DCMTK_LOG4CPLUS_TEXT (" already been destroyed.\n")
+            DCMTK_LOG4CPLUS_TEXT ("The memory will be leaked."));
+
+    default_context_state = DC_INITIALIZED;
+}
+
+
+static
+DefaultContext *
+get_dc (bool alloc = true)
+{
+    if (DCMTK_LOG4CPLUS_UNLIKELY (! default_context && alloc))
+        alloc_dc ();
+    return default_context;
+}
+
+
+} // namespace
+
+
+namespace helpers
+{
+
+
+log4cplus::thread::Mutex const & getConsoleOutputMutex ();
+
+log4cplus::thread::Mutex const &
+getConsoleOutputMutex ()
+{
+    return get_dc ()->console_mutex;
+}
+
+
+LogLog &
+getLogLog ()
+{
+    return get_dc ()->loglog;
+}
+
+
+} // namespace helpers
+
+
+helpers::Time const &
+getTTCCLayoutTimeBase ()
+{
+    return get_dc ()->TTCCLayout_time_base;
+}
+
+
+LogLevelManager &
+getLogLevelManager () 
+{
+    return get_dc ()->log_level_manager;
+}
+
+
+Hierarchy &
+getDefaultHierarchy ()
+{
+    return get_dc ()->hierarchy;
+}
+
+
+NDC & 
+getNDC ()
+{
+    return get_dc ()->ndc;
+}
+
+
+MDC &
+getMDC ()
+{
+    return get_dc ()->mdc;
+}
+
+
+namespace spi
+{
+
+
+AppenderFactoryRegistry &
+getAppenderFactoryRegistry ()
+{
+    return get_dc ()->appender_factory_registry;
+}
+
+
+LayoutFactoryRegistry &
+getLayoutFactoryRegistry ()
+{
+    return get_dc ()->layout_factory_registry;
+}
+
+
+FilterFactoryRegistry &
+getFilterFactoryRegistry ()
+{
+    return get_dc ()->filter_factory_registry;
+}
+
+
+LocaleFactoryRegistry &
+getLocaleFactoryRegistry()
+{
+    return get_dc ()->locale_factory_registry;
+}
+
+
+} // namespace spi
+
+
+namespace internal
+{
+
+
+gft_scratch_pad::gft_scratch_pad ()
+    : q_str()
+    , uc_q_str()
+    , s_str()
+    , ret()
+    , fmt()
+    , tmp()
+    , buffer()
+    , uc_q_str_valid (false)
+    , q_str_valid (false)
+    , s_str_valid (false)
+{ }
+
+
+gft_scratch_pad::~gft_scratch_pad ()
+{ }
+
+
+appender_sratch_pad::appender_sratch_pad ()
+    : oss()
+    , str()
+    , chstr()
+{ }
+
+
+appender_sratch_pad::~appender_sratch_pad ()
+{ }
+
+
+per_thread_data::per_thread_data ()
+    : macros_oss ()
+    , layout_oss ()
+    , ndc_dcs ()
+    , mdc_map ()
+    , thread_name ()
+    , thread_name2 ()
+    , gft_sp ()
+    , appender_sp ()
+    , faa_str ()
+    , ll_str ()
+    , forced_log_ev ()
+    , fnull (0)
+    , snprintf_buf ()
+{ }
+
+
+per_thread_data::~per_thread_data ()
+{
+    if (fnull)
+        fclose (fnull);
+}
+
+
+log4cplus::thread::impl::tls_key_type tls_storage_key;
+
+
+#if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED) \
+    && defined (DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR)
+
+DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR per_thread_data * ptd = 0;
+
+
+per_thread_data *
+alloc_ptd ()
+{
+    per_thread_data * tmp = new per_thread_data;
+    set_ptd (tmp);
+    // This is a special hack. We set the keys' value to non-NULL to
+    // get the ptd_cleanup_func to execute when this thread ends. The
+    // cast is safe; the associated value will never be used if read
+    // again using the key.
+    thread::impl::tls_set_value (tls_storage_key,
+        OFreinterpret_cast(void *, 1));
+
+    return tmp;
+}
+
+#  else
+
+per_thread_data *
+alloc_ptd ()
+{
+    per_thread_data * tmp = new per_thread_data;
+    set_ptd (tmp);
+    return tmp;
+}
+
+#  endif
+
+
+} // namespace internal
+
 
 void initializeFactoryRegistry();
 
 
+//! Thread local storage clean up function for POSIX threads.
+static
+void
+ptd_cleanup_func (void * arg)
+{
+    internal::per_thread_data * const arg_ptd
+        = OFstatic_cast(internal::per_thread_data *, arg);
+    internal::per_thread_data * const ptd = internal::get_ptd (false);
+    (void) ptd;
+
+    // Either it is a dummy value or it should be the per thread data
+    // pointer we get from internal::get_ptd().
+    assert (arg == OFreinterpret_cast(void *, 1)
+        || arg_ptd == ptd
+        || (! ptd && arg_ptd));
+
+    if (arg == OFreinterpret_cast(void *, 1))
+        // Setting the value through the key here is necessary in case
+        // we are using TLS using __thread or __declspec(thread) or
+        // similar constructs with POSIX threads.  Otherwise POSIX
+        // calls this cleanup routine more than once if the value
+        // stays non-NULL after it returns.
+        thread::impl::tls_set_value (internal::tls_storage_key, 0);
+    else if (arg)
+    {
+        // Instead of using internal::get_ptd(false) here we are using
+        // the value passed to this function directly.  This is
+        // necessary because of the following (from SUSv4):
+        //
+        // A call to pthread_getspecific() for the thread-specific
+        // data key being destroyed shall return the value NULL,
+        // unless the value is changed (after the destructor starts)
+        // by a call to pthread_setspecific().
+        delete arg_ptd;
+        thread::impl::tls_set_value (internal::tls_storage_key, 0);
+    }
+    else
+    {
+        // In this case we fall through to threadCleanup() and it does
+        // all the necessary work itself.
+        ;
+    }
+
+    threadCleanup ();
+}
+
+
+static
+void
+threadSetup ()
+{
+    internal::get_ptd (true);
+}
+
+
 void initializeLog4cplus();
+
 void initializeLog4cplus()
 {
     static bool initialized = false;
     if (initialized)
         return;
 
-    helpers::LogLog::getLogLog();
-    getLogLevelManager ();
-    getNDC();
+    internal::tls_storage_key = thread::impl::tls_init (ptd_cleanup_func);
+    threadSetup ();
+
+    DefaultContext * dc = get_dc (true);
+    dc->TTCCLayout_time_base = helpers::Time::gettimeofday ();
     Logger::getRoot();
     initializeFactoryRegistry();
 
@@ -52,50 +417,93 @@ void initializeLog4cplus()
 }
 
 
-} // namespace log4cplus
+void
+threadCleanup ()
+{
+    // Do thread-specific cleanup.
+    internal::per_thread_data * ptd = internal::get_ptd (false);
+    delete ptd;
+    internal::set_ptd (0);
+}
 
-} // namespace dcmtk
+
+} // namespace log4cplus
+} // end namespace dcmtk
 
 
 #if defined (_WIN32) && defined (DCMTK_LOG4CPLUS_BUILD_DLL)
 
-BOOL WINAPI DllMain(DCMTK_LOG4CPLUS_DLLMAIN_HINSTANCE hinstDLL,  // handle to DLL module
-                    DWORD fdwReason,     // reason for calling function
-                    LPVOID lpReserved )  // reserved
+extern "C"
+BOOL
+WINAPI
+DllMain (DCMTK_LOG4CPLUS_DLLMAIN_HINSTANCE /*hinstDLL*/, DWORD fdwReason,
+    LPVOID /*lpReserved*/)
 {
     // Perform actions based on the reason for calling.
-    switch( fdwReason )
+    switch( fdwReason ) 
+    { 
+    case DLL_PROCESS_ATTACH:
     {
-        case DLL_PROCESS_ATTACH:
-            dcmtk::log4cplus::initializeLog4cplus();
-            break;
+        log4cplus::initializeLog4cplus();
+
+        // Do thread-specific initialization for the main thread.
+        log4cplus::threadSetup ();
+
+        break;
+    }
+
+    case DLL_THREAD_ATTACH:
+    {
+        // Do thread-specific initialization.
+        log4cplus::threadSetup ();
+
+        break;
+    }
+
+    case DLL_THREAD_DETACH:
+    {
+        // Do thread-specific cleanup.
+        log4cplus::threadCleanup ();
 
-        case DLL_THREAD_ATTACH:
-         // Do thread-specific initialization.
-            break;
+        break;
+    }
+
+    case DLL_PROCESS_DETACH:
+    {
+        // Perform any necessary cleanup.
 
-        case DLL_THREAD_DETACH:
-         // Do thread-specific cleanup.
-            break;
+        // Do thread-specific cleanup.
+        log4cplus::threadCleanup ();
+#if ! defined (DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR)
+        log4cplus::thread::impl::tls_cleanup (
+            log4cplus::internal::tls_storage_key);
+#endif
+        break;
+    }
 
-        case DLL_PROCESS_DETACH:
-         // Perform any necessary cleanup.
-            break;
     }
 
     return TRUE;  // Successful DLL_PROCESS_ATTACH.
 }
-
+ 
 #else
 
 namespace {
 
-    class _static_log4cplus_initializer {
-    public:
-        _static_log4cplus_initializer() {
+    struct _static_log4cplus_initializer
+    {
+        _static_log4cplus_initializer ()
+        {
             dcmtk::log4cplus::initializeLog4cplus();
         }
+
+        ~_static_log4cplus_initializer ()
+        {
+            // Last thread cleanup.
+            dcmtk::log4cplus::threadCleanup ();
+        }
     } static initializer;
 }
 
+
 #endif
diff --git a/oflog/libsrc/hierarchy.cc b/oflog/libsrc/hierarchy.cc
index ef2bbdf..6945f74 100644
--- a/oflog/libsrc/hierarchy.cc
+++ b/oflog/libsrc/hierarchy.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -22,13 +22,14 @@
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/spi/logimpl.h"
 #include "dcmtk/oflog/spi/rootlog.h"
-//#include <utility>
+#include "dcmtk/oflog/thread/syncpub.h"
+#include <utility>
 
-#define INCLUDE_CSTDLIB
-#include "dcmtk/ofstd/ofstdinc.h"
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
+namespace dcmtk
+{
+namespace log4cplus
+{
 
 
 //////////////////////////////////////////////////////////////////////////////
@@ -53,7 +54,7 @@ bool startsWith(tstring const & teststr, tstring const & substr)
 
 
 //////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::Hierarchy static declarations
+// Hierarchy static declarations
 //////////////////////////////////////////////////////////////////////////////
 
 const LogLevel Hierarchy::DISABLE_OFF = -1;
@@ -62,16 +63,18 @@ const LogLevel Hierarchy::DISABLE_OVERRIDE = -2;
 
 
 //////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::Hierarchy ctor and dtor
+// Hierarchy ctor and dtor
 //////////////////////////////////////////////////////////////////////////////
 
 Hierarchy::Hierarchy()
-  : hashtable_mutex(DCMTK_LOG4CPLUS_MUTEX_CREATE),
-    defaultFactory(new DefaultLoggerFactory()),
-    root(NULL),
-    disableValue(DISABLE_OFF),  // Don't disable any LogLevel level by default.
-    emittedNoAppenderWarning(false),
-    emittedNoResourceBundleWarning(false)
+  : hashtable_mutex ()
+  , defaultFactory(new DefaultLoggerFactory())
+  , provisionNodes()
+  , loggerPtrs()
+  , root(NULL)
+  // Don't disable any LogLevel level by default.
+  , disableValue(DISABLE_OFF)
+  , emittedNoAppenderWarning(false)
 {
     root = Logger( new spi::RootLogger(*this, DEBUG_LOG_LEVEL) );
 }
@@ -80,36 +83,35 @@ Hierarchy::Hierarchy()
 Hierarchy::~Hierarchy()
 {
     shutdown();
-    DCMTK_LOG4CPLUS_MUTEX_FREE( hashtable_mutex );
 }
 
 
 
 //////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::Hierarchy public methods
+// Hierarchy public methods
 //////////////////////////////////////////////////////////////////////////////
 
-void
-Hierarchy::clear()
+void 
+Hierarchy::clear() 
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( hashtable_mutex )
-        provisionNodes.erase(provisionNodes.begin(), provisionNodes.end());
-        loggerPtrs.erase(loggerPtrs.begin(), loggerPtrs.end());
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    thread::MutexGuard guard (hashtable_mutex);
+
+    provisionNodes.erase(provisionNodes.begin(), provisionNodes.end());
+    loggerPtrs.erase(loggerPtrs.begin(), loggerPtrs.end());
 }
 
 
 bool
 Hierarchy::exists(const tstring& name)
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( hashtable_mutex )
-        LoggerMap::iterator it = loggerPtrs.find(name);
-        return it != loggerPtrs.end();
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    thread::MutexGuard guard (hashtable_mutex);
+
+    LoggerMap::iterator it = loggerPtrs.find(name);
+    return it != loggerPtrs.end();
 }
 
 
-void
+void 
 Hierarchy::disable(const tstring& loglevelStr)
 {
     if(disableValue != DISABLE_OVERRIDE) {
@@ -118,8 +120,8 @@ Hierarchy::disable(const tstring& loglevelStr)
 }
 
 
-void
-Hierarchy::disable(LogLevel ll)
+void 
+Hierarchy::disable(LogLevel ll) 
 {
     if(disableValue != DISABLE_OVERRIDE) {
         disableValue = ll;
@@ -127,78 +129,79 @@ Hierarchy::disable(LogLevel ll)
 }
 
 
-void
-Hierarchy::disableAll()
-{
+void 
+Hierarchy::disableAll() 
+{ 
     disable(FATAL_LOG_LEVEL);
 }
 
 
-void
-Hierarchy::disableDebug()
-{
+void 
+Hierarchy::disableDebug() 
+{ 
     disable(DEBUG_LOG_LEVEL);
 }
 
 
-void
-Hierarchy::disableInfo()
-{
+void 
+Hierarchy::disableInfo() 
+{ 
     disable(INFO_LOG_LEVEL);
 }
 
 
-void
-Hierarchy::enableAll()
-{
-    disableValue = DISABLE_OFF;
+void 
+Hierarchy::enableAll() 
+{ 
+    disableValue = DISABLE_OFF; 
 }
 
 
-Logger
-Hierarchy::getInstance(const tstring& name)
-{
-    return getInstance(name, *defaultFactory);
+Logger 
+Hierarchy::getInstance(const tstring& name) 
+{ 
+    return getInstance(name, *defaultFactory); 
 }
 
 
-Logger
+Logger 
 Hierarchy::getInstance(const tstring& name, spi::LoggerFactory& factory)
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( hashtable_mutex )
-        return getInstanceImpl(name, factory);
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    thread::MutexGuard guard (hashtable_mutex);
+
+    return getInstanceImpl(name, factory);
 }
 
 
-LoggerList
+LoggerList 
 Hierarchy::getCurrentLoggers()
 {
     LoggerList ret;
-
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( hashtable_mutex )
+    
+    {
+        thread::MutexGuard guard (hashtable_mutex);
         initializeLoggerList(ret);
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    }
 
     return ret;
 }
 
 
-bool
-Hierarchy::isDisabled(int level)
-{
-    return disableValue >= level;
+bool 
+Hierarchy::isDisabled(LogLevel level) 
+{ 
+    return disableValue >= level; 
 }
 
 
-Logger
+Logger 
 Hierarchy::getRoot() const
-{
-    return root;
+{ 
+    return root; 
 }
 
 
-void
+void 
 Hierarchy::resetConfiguration()
 {
     getRoot().setLogLevel(DEBUG_LOG_LEVEL);
@@ -207,24 +210,31 @@ Hierarchy::resetConfiguration()
     shutdown();
 
     LoggerList loggers = getCurrentLoggers();
-    LoggerListIterator it = loggers.begin();
-    while(it != loggers.end()) {
-        (*it).setLogLevel(NOT_SET_LOG_LEVEL);
-        (*it).setAdditivity(true);
-        ++it;
+    for (LoggerList::iterator it = loggers.begin (); it != loggers.end(); ++it)
+    {
+        Logger & logger = *it;
+        logger.setLogLevel(NOT_SET_LOG_LEVEL);
+        logger.setAdditivity(true);
     }
 
 }
 
 
-void
-Hierarchy::setLoggerFactory(OFauto_ptr<spi::LoggerFactory> factory)
+void 
+Hierarchy::setLoggerFactory(OFauto_ptr<spi::LoggerFactory> factory) 
+{ 
+    defaultFactory = factory; 
+}
+
+
+spi::LoggerFactory *
+Hierarchy::getLoggerFactory()
 {
-    defaultFactory = factory;
+    return defaultFactory.get();
 }
 
 
-void
+void 
 Hierarchy::shutdown()
 {
     LoggerList loggers = getCurrentLoggers();
@@ -235,79 +245,87 @@ Hierarchy::shutdown()
     root.removeAllAppenders();
 
     // repeat
-    LoggerListIterator it = loggers.begin();
-    while(it != loggers.end()) {
-        (*it).closeNestedAppenders();
-        (*it).removeAllAppenders();
-        ++it;
+    for (LoggerList::iterator it = loggers.begin(); it != loggers.end(); ++it)
+    {
+        Logger & logger = *it;
+        logger.closeNestedAppenders();
+        logger.removeAllAppenders();
     }
 }
 
 
 
 //////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::Hierarchy private methods
+// Hierarchy private methods
 //////////////////////////////////////////////////////////////////////////////
 
-Logger
+Logger 
 Hierarchy::getInstanceImpl(const tstring& name, spi::LoggerFactory& factory)
 {
-    LoggerMap::iterator it = loggerPtrs.find(name);
-     if(it != loggerPtrs.end()) {
-         return (*it).second;
-     }
-     else {
-         // Need to create a new logger
-         Logger logger = factory.makeNewLoggerInstance(name, *this);
-         bool inserted = loggerPtrs.insert(OFMake_pair(name, logger)).second;
-         if(!inserted) {
-             getLogLog().error(DCMTK_LOG4CPLUS_TEXT("Hierarchy::getInstanceImpl()- Insert failed"));
-             //throw STD_NAMESPACE runtime_error("Hierarchy::getInstanceImpl()- Insert failed");
-             abort();
-         }
-
-         ProvisionNodeMap::iterator it2 = provisionNodes.find(name);
-         if(it2 != provisionNodes.end()) {
-             updateChildren(it2->second, logger);
-             bool deleted = (provisionNodes.erase(name) > 0);
-             if(!deleted) {
-                 getLogLog().error(DCMTK_LOG4CPLUS_TEXT("Hierarchy::getInstanceImpl()- Delete failed"));
-                 //throw STD_NAMESPACE runtime_error("Hierarchy::getInstanceImpl()- Delete failed");
-                 abort();
-             }
-         }
-         updateParents(logger);
-
-         return logger;
-     }
+    Logger logger;
+    LoggerMap::iterator lm_it;
+
+    if (name.empty ())
+        logger = root;
+    else if ((lm_it = loggerPtrs.find(name)) != loggerPtrs.end())
+        logger = lm_it->second;
+    else
+    {
+        // Need to create a new logger
+        logger = factory.makeNewLoggerInstance(name, *this);
+        bool inserted = loggerPtrs.insert(OFMake_pair(name, logger)).second;
+        if (! inserted)
+        {
+            helpers::getLogLog().error(
+                DCMTK_LOG4CPLUS_TEXT("Hierarchy::getInstanceImpl()- Insert failed"),
+                true);
+        }
+
+        ProvisionNodeMap::iterator pnm_it = provisionNodes.find(name);
+        if (pnm_it != provisionNodes.end())
+        {
+            updateChildren(pnm_it->second, logger);
+            bool deleted = (provisionNodes.erase(name) > 0);
+            if (! deleted)
+            {
+                helpers::getLogLog().error(
+                    DCMTK_LOG4CPLUS_TEXT("Hierarchy::getInstanceImpl()- Delete failed"),
+                    true);
+            }
+        }
+        updateParents(logger);
+    }
+
+    return logger;
 }
 
 
-void
+void 
 Hierarchy::initializeLoggerList(LoggerList& list) const
 {
-    for(LoggerMap::const_iterator it=loggerPtrs.begin();
-        it!= loggerPtrs.end();
-        ++it)
+    for(LoggerMap::const_iterator it=loggerPtrs.begin(); 
+        it!= loggerPtrs.end(); 
+        ++it) 
     {
         list.push_back((*it).second);
     }
 }
 
 
-void
-Hierarchy::updateParents(Logger logger)
+void 
+Hierarchy::updateParents(Logger const & logger)
 {
-    tstring name = logger.getName();
-    size_t length = name.length();
+    tstring const & name = logger.getName();
+    size_t const length = name.length();
     bool parentFound = false;
+    tstring substr;
 
     // if name = "w.x.y.z", loop thourgh "w.x.y", "w.x" and "w", but not "w.x.y.z"
     for(size_t i=name.find_last_of(DCMTK_LOG4CPLUS_TEXT('.'), length-1);
-        i != OFString_npos;
-        i = name.find_last_of(DCMTK_LOG4CPLUS_TEXT('.'), i-1))
+        i != OFString_npos && i > 0;
+        i = name.find_last_of(DCMTK_LOG4CPLUS_TEXT('.'), i-1)) 
     {
-        tstring substr = name.substr(0, i);
+        substr.assign (name, 0, i);
 
         LoggerMap::iterator it = loggerPtrs.find(substr);
         if(it != loggerPtrs.end()) {
@@ -325,11 +343,11 @@ Hierarchy::updateParents(Logger logger)
                 node.push_back(logger);
                 OFPair<ProvisionNodeMap::iterator, bool> tmp =
                     provisionNodes.insert(OFMake_pair(substr, node));
-                //bool inserted = provisionNodes.insert(STD_NAMESPACE make_pair(substr, node)).second;
+                //bool inserted = provisionNodes.insert(OFMake_pair(substr, node)).second;
                 if(!tmp.second) {
-                    getLogLog().error(DCMTK_LOG4CPLUS_TEXT("Hierarchy::updateParents()- Insert failed"));
-                    //throw STD_NAMESPACE runtime_error("Hierarchy::updateParents()- Insert failed");
-                    abort();
+                    helpers::getLogLog().error(
+                        DCMTK_LOG4CPLUS_TEXT("Hierarchy::updateParents()- Insert failed"),
+                        true);
                 }
             }
         } // end if Logger found
@@ -341,11 +359,11 @@ Hierarchy::updateParents(Logger logger)
 }
 
 
-void
-Hierarchy::updateChildren(ProvisionNode& pn, Logger logger)
+void 
+Hierarchy::updateChildren(ProvisionNode& pn, Logger const & logger)
 {
 
-    for(ProvisionNodeIterator it=pn.begin(); it!=pn.end(); ++it) {
+    for(ProvisionNode::iterator it=pn.begin(); it!=pn.end(); ++it) {
         Logger& c = *it;
         // Unless this child already points to a correct (lower) parent,
         // make logger.parent point to c.parent and c.parent to logger.
@@ -356,3 +374,6 @@ Hierarchy::updateChildren(ProvisionNode& pn, Logger logger)
     }
 }
 
+
+} // namespace log4cplus
+} // end namespace dcmtk
